<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="dashBoardDAO">

    <resultMap id="kpiInfo" type="egovframework.com.dash.service.vo.KpiInfoVO"></resultMap>
    <resultMap id="globalKpiData" type="egovframework.com.dash.service.vo.GlobalKpiDataVO"></resultMap>
    <resultMap id="factoryInfoVO" type="egovframework.com.dash.service.vo.FactoryInfoVO"></resultMap>
    <resultMap id="kpiDataVO" type="egovframework.com.dash.service.vo.KpiDataVO"></resultMap>

    <select id="selectMapLocation" resultType="egovframework.com.dash.service.vo.MapLocationVO">
		EXEC [CPALSDB].[dbo].[CPALS_GlobalMap2]
    </select>

    <!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="selectFactoryMessage" parameterType="egovframework.com.dash.service.criteria.DashBoardCriteria"
            resultType="egovframework.com.dash.service.vo.FactoryMessageVO">
		EXEC [CPALSDB].[dbo].[CPALS_GlobalEvent2] @Day =#{date},@UserID =#{userId}
    </select>

    <!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="selectGlobalMap" parameterType="egovframework.com.dash.service.criteria.DashBoardCriteria"
            resultMap="kpiInfo,globalKpiData">
		EXEC [CPALSDB].[dbo].[CPALS_GlobalKPI2] @Day =#{date},@UserID =#{userId}
    </select>

    <!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="selectFactorylMap" parameterType="egovframework.com.dash.service.criteria.DashBoardCriteria"
            resultMap="factoryInfoVO,kpiInfo, kpiDataVO">
	EXEC [CPALSDB].[dbo].[CPALS_FactoryKPI2] @Day =#{date},@FactoryID=#{factoryId},@FaotoryType=#{factoryType}, @UserID =#{userId}
    </select>

    <!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="getFactory3DInfo" parameterType="egovframework.com.dash.service.criteria.DashBoard3DCriteria"
            resultType="egovframework.com.dash.service.vo.Monitor3DVO">
		EXEC [CPALSDB].[dbo].[CPALS_CompanyFactory] @ModelID=#{modelId}, @LVL =#{level}
	</select>

    <!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="getSimulation" parameterType="egovframework.com.dash.service.criteria.SimulationCriteria"
            resultType="egovframework.com.sim.service.vo.ProcessMapInfoVO">
    	SELECT
             MAP_ID as mapId,
             MODEL_ITEM_ID as modelItemId,
             MAP_RANGE_LEN_X as mapRangeLenx,
             MAP_RANGE_LEN_Y as mapRangeLeny,
             MAP_RANGE_LEN_Z as mapRangeLenz,
             MAP_GRID_X as mapGridx,
             MAP_GRID_Y as mapGridy,
             MAP_GRID_Z as mapGridz
        FROM MAP_MAS
        WHERE MAP_ID =#{mapId}
	</select>

<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="getModel" parameterType="egovframework.com.dash.service.criteria.SimulationCriteria"
            resultType="egovframework.com.sim.service.vo.ProcessModelInfoVO">

        select
            A.STENC_ID as stencId,
            Replace(A.STENC_NM,' ' ,'_') as stencNm,
            A.STENC_LEN_X as stencLenx,
            A.STENC_LEN_Y as stencLeny,
            A.STENC_LEN_Z as stencLenz,
            A.STENC_POS_X as stencPosx,
            A.STENC_POS_Y as stencPosy,
            A.STENC_POS_Z as stencPosz,
            A.Z_INDEX as zIndex,
            A.MAP_ID as mapId,
            A.ROT_ANGLE as rotAngle,
            C.STENC_3D_TP  as stenc3dTp,
            C.SCALE as modelScale,
            B.STENC_3D_ID as stenc3did,
            D.STENC_3D_INFO_ID as stenc3dinfoid,
            D.STENC_3D_FILE as stenc3dfile,
            F.FILL_COLOR,
            substring(F.FILL_COLOR, 4, 8) as fillColor,
            substring(F.LINE_COLOR, 4, 8)  as lineColor
    FROM STE_INFO A
         LEFT OUTER JOIN STE_TMPL_MAS B  ON A.STENC_TMPL_ID = B.STENC_TMPL_ID
         LEFT OUTER JOIN STE_3D_MAS C    ON B.STENC_3D_ID = C.STENC_3D_ID
         LEFT OUTER JOIN STE_3D_INFO D   ON B.STENC_3D_ID = D.STENC_3D_ID
         INNER JOIN STE_SHP_INFO E ON E.STENC_ID = A.STENC_ID
         INNER JOIN SHP_APPR_INFO F ON F.SHAPE_APPR_ID = E.SHAPE_APPR_ID
    WHERE A.MAP_ID =#{mapId}
	</select>

<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="getKpiMaster" resultType="egovframework.com.dash.service.vo.KpiMasterVO">
	select A.KPIID as kpiId,A.UIType as uiType, A.Unit as unit, A.Description as description, A.Scope as scope,
	       A.Formula as formula, A.UnitOfMeasure as unitOfMeasure, Range as range, A.KPIName as kpiName,A.Trend as trend,
	       A.Timing as timing, A.Audience as audience, A.ProdMeth as prodMeth, A.Notes as notes, A.MainCate as mainCate,
	       A.MidCate as midCate, A.SubCate as subCate, A.Preference as preference, A.DiagramFile as diagramFile, A.Day as day,
	       A.Time as time, A.Writer as writer
        from [CPALSDB].[dbo].CPALS_KPIMaster2 A
        order by A.KPIID

    </select>

<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <insert id="insertKpiMaster" parameterType="egovframework.com.dash.service.vo.KpiMasterVO">
INSERT INTO [CPALSDB].[dbo].CPALS_KPIMaster2(KPIID, KPIName, UIType, Unit,Description, Scope,Formula, UnitOfMeasure,
                  Range, Trend, Timing, Audience, ProdMeth, Notes, MainCate, MidCate, SubCate, Preference,
                  DiagramFile, Day, Time, Writer )
VALUES (#{kpiId}, #{kpiName}, #{uiType}, #{unit}, #{description}, #{scope}, #{formula}, #{unitOfMeasure}, #{range},
                  #{trend}, #{timing}, #{audience}, #{prodMeth}, #{notes}, #{mainCate}, #{midCate}, #{subCate},
                  #{preference}, #{diagramFile}, #{day}, #{time}, #{writer});
    </insert>

<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <insert id="insertBatch">
    EXEC [CPALSDB].[dbo].[CPALS_KPIRecordBatch]
    </insert>

<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <delete id="deleteKpiMaster" parameterType="egovframework.com.dash.service.vo.DeleteDataVO">
        <foreach item="selectKpiId" index="index" collection="selectKpiId"  separator=";">
            DELETE FROM [CPALSDB].[dbo].CPALS_KPIMaster2 where KPIID =#{selectKpiId};
        </foreach>
    </delete>

<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <update id="updateKpiMaster" parameterType="egovframework.com.dash.service.vo.KpiMasterVO">
      UPDATE [CPALSDB].[dbo].CPALS_KPIMaster2  set KPIID=#{kpiId}, KPIName=#{kpiName}, UIType=#{uiType}, Unit= #{unit},
                Description=#{description}, Scope=#{scope},Formula=#{formula}, UnitOfMeasure=#{unitOfMeasure},
                Range=#{range}, Trend=#{trend}, Timing=#{timing}, Audience=#{audience}, ProdMeth=#{prodMeth},
                Notes=#{notes}, MainCate=#{mainCate}, MidCate=#{midCate}, SubCate=#{subCate}, Preference=#{preference},
                DiagramFile=#{diagramFile}
       where KPIID = #{kpiId}
    </update>
<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="getKpiRecord" parameterType="egovframework.com.dash.service.criteria.SimulationCriteria"
            resultType="egovframework.com.dash.service.vo.KpiRecordVO">
	select  A.RelatedID as relatedId,
			B.P_ID as p_id,
            B.Name as name,
            A.KPIID as kpiId,
            A.Text as text,
            A.Value as value,
            A.Unit as unit,
            A.Day as day
     from [CPALSDB].[dbo].CPALS_KPIRecord2 A
              INNER JOIN [CPALSDB].[dbo].VW_GlobalMap B
                         on A.RelatedID = B.ID
                         where Day = #{day}
    </select>

<!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <select id="getSearch" parameterType="egovframework.com.dash.service.criteria.KpiSearchCriteria"
            resultType="egovframework.com.dash.service.vo.KpiSearchVO">
	select  A.ID as id, A.Type as type, A.Name as name, A.HirerachyName as hirerachyName
          from [CPALSDB].[dbo].VW_GlobalMap A
          where A.P_ID = #{id}
    </select>

 <!--▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒▒-->
    <update id="updateKpiRecord" parameterType="egovframework.com.dash.service.vo.KpiRecordVO">
      UPDATE [CPALSDB].[dbo].CPALS_KPIRecord2  set KPIID=#{kpiId}, Text =#{text}, Value =#{value}, Unit =#{unit}, Day =#{day}
       where KPIID = #{kpiId} and Day = #{day} and Text = #{text} and RelatedID = #{relatedId}
    </update>
</mapper>

